// bool.mux6.cc  INCLUDE file
// W.B.Langdon cwi.nl $Revision: 1.11 $

//Modifications (reverse order):

// WBL 29 Jun 1999 BUGFIX (30 Apr, r1.10) for D6-D12
// WBL 30 Apr 1999 Conversion for SiliconGraphics cc -c -64 -mips4
// WBL  9 Jan 1999 based on bool.test64.cc r1.4, use RMP's smc_gp.c
// WBL 11 Jun 1998 Add just testing even parity problems
// WBL  5 Mar 1998 New file

{
#ifdef FASTTRAVERSE
assert(1==0) submachine code not compatible with FASTTRAVERSE
#endif

//part of smc_gp.cc
/* 
 * Program:      smc_gp.c
 *
 * Author:       Riccardo Poli (email: R.Poli@cs.bham.ac.uk)
 *               School of Computer Science
 *               The University of Birmingham
 *               UK
 *
 * Creation date: August 1998
 *
 * Description: Parallel evaluation of multiple fitness cases in genetic
 *              programming  using sub-machine-code GP. For more information
 *              see Technical Report CSRP-98-18, available at
 *             
 *              ftp://ftp.cs.bham.ac.uk/pub/tech-reports/1998/CSRP-98-18.ps.gz
 * 
 *              This program is available at
 *
 *              ftp://ftp.cs.bham.ac.uk/pub/Authors/R.Poli/code/smc_gp.c
 *
 * Notes:       This code works both on 32 and 64 bit machines. However, the
 *              additional 32 bits available on 64 bit machines would allow
 *              doubling the speed of this code, with minor changes.
 */

/* This file is Copyright (c) 1998 Riccardo Poli.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met: 1. Redistributions of source code must retain the above
 * copyright notice, this list of conditions and the following
 * disclaimer.  2.  Redistributions in binary form must reproduce the
 * above copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution.  3.  Neither the name of the Author nor the
 * names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.  
 */
//end smc_gp

  int fit = 0;
  int test  = 0;
  //int i32 = 0;
  int i64 = 0;
  for(int cx12=0; cx12<=data_limit[12]; cx12++) {
    data[12]  = (cx12==0)? 0 : 0xffffffffffffffff;
  for(int cx11=0; cx11<=data_limit[11]; cx11++) {
    data[11]  = (cx11==0)? 0 : 0xffffffffffffffff;
  for(int cx10=0; cx10<=data_limit[10]; cx10++) {
    data[10]  = (cx10==0)? 0 : 0xffffffffffffffff;
  for(int cx9 =0; cx9 <=data_limit[9];  cx9++) {
    data[9]  =  (cx9==0)? 0 : 0xffffffffffffffff;
  for(int cx8 =0; cx8 <=data_limit[8];  cx8++) {
    data[8]  =  (cx8==0)? 0 : 0xffffffffffffffff;
  for(int cx7 =0; cx7 <=data_limit[7];  cx7++) {
    data[7]  =  (cx7==0)? 0 : 0xffffffffffffffff;
  for(int cx6 =0; cx6 <=data_limit[6];  cx6++) {
    data[6]  =  (cx6==0)? 0 : 0xffffffffffffffff;
  //for(int cx5 =0; cx5 <=data_limit[5];  cx5++) {
    //data[5]  =  (cx5==0)? 0 : 0xffffffff;

  const unsigned long result = chrome->evalAll(0);
#ifdef DISPLAY
  cout<<test<<"\t"; 
  cout<<cx12<<",";
  cout<<cx11<<","<<cx10<<","<<cx9<<",";
  cout<<cx8<<","<<cx7<<","<<cx6<<",";
  //cout<<cx5<<" ";
  char buf[80]; sprintf(buf,"%016lx",result); cout<<buf<<flush;
#else
    tests_run++;
#endif
    
#ifdef ALLFUNC_LIB
  ptrmyfitnessvalue(chrome->nfitness)->Ntests_run = result; 
  //avoid conversion to float inherit in return, cf doscores
#else //ALLFUNC_LIB

  const retval matches = ~(result ^ (mux64[i64])); /* Find bits where TARGET = RESULT */
  retval filter = 1; 
  for(int i = 0; i < 64; i ++ )    /* Count bits set in MATCHES */
    {
      if(  matches & filter   ) fit ++; 
      filter <<= 1; 
    }
#endif /*ALLFUNC_LIB*/
#ifdef DISPLAY
  cout<<"\t"<<fit;
  if(result!=mux64[i64]) cout<<" *";
  cout<<endl;
#endif
    test++;
  i64++;
  }}}}}}} //endfor
#ifdef DISPLAY
//  cout<<"Ran up to test "<<test<<" score "<<a<<" "<<flush;
//  cout<<endl;
  return 0;
#else
  chrome->nfitness->fvalue = float(fit);
  return float(fit);
#endif

//end MUX6 MUX11
}
